# CbcGenParam Class Reference

Class for cbc-generic control parameters. More...

`#include <CbcGenParam.hpp>`

Inheritance diagram for CbcGenParam:
[legend]
Collaboration diagram for CbcGenParam:
[legend]

List of all members.

## Public Types
Subtypes
enum | CbcGenParamCode { CBCGEN_FIRSTPARAM = 0, GENERALQUERY, FULLGENERALQUERY, HELP, BAB, CLEARCUTS, CLIQUECUTS, COMBINE, COSTSTRATEGY, CPP, CUTDEPTH, CUTSTRATEGY, DEBUG, DIRECTORY, DJFIX, DUMMY, ERRORSALLOWED, EXIT, EXPORT, FLOWCUTS, FPUMP, FPUMPITS, GOMORYCUTS, GREEDY, HEURISTICSTRATEGY, IMPORT, INTPRINT, KNAPSACKCUTS, LOCALTREE, LOGLEVEL, MESSAGES, MIPLIB, MIXEDCUTS, ODDHOLECUTS, OUTDUPROWS, OUTPUTFORMAT, PREPROCESS, PRINTMASK, PRINTOPTIONS, PRINTVERSION, PRIORITYIN, PROBINGCUTS, REDSPLITCUTS, ROUNDING, SOLUTION, SOLVECONTINUOUS, SOLVER, SOS, STDIN, STRENGTHEN, TIGHTENFACTOR, TWOMIRCUTS, UNITTEST, USERCBC, USESOLUTION, VERBOSE, SHOWUNIMP, CBCGEN_LASTPARAM }
| Enumeration for cbc-generic parameters. More...
## Public Member Functions
Constructors and Destructors
Be careful how you specify parameters for the constructors! There's great potential for confusion.
| CbcGenParam ()
| Default constructor.
| CbcGenParam (CbcGenParamCode code, std::string name, std::string help, double lower, double upper, double dflt=0.0, bool display=true)
| Constructor for a parameter with a double value.
| CbcGenParam (CbcGenParamCode code, std::string name, std::string help, int lower, int upper, int dflt=0, bool display=true)
| Constructor for a parameter with an integer value.
| CbcGenParam (CbcGenParamCode code, std::string name, std::string help, std::string firstValue, int dflt, bool display=true)
| Constructor for a parameter with keyword values.
| CbcGenParam (CbcGenParamCode code, std::string name, std::string help, std::string dflt, bool display=true)
| Constructor for a string parameter.
| CbcGenParam (CbcGenParamCode code, std::string name, std::string help, bool display=true)
| Constructor for an action parameter.
| CbcGenParam (const CbcGenParam &orig)
| Copy constructor.
CbcGenParam * | clone ()
| Clone.
CbcGenParam & | operator= (const CbcGenParam &rhs)
| Assignment.
| ~CbcGenParam ()
| Destructor.
Methods to query and manipulate a parameter object
CbcGenParamCode | paramCode () const
| Get the parameter code.
void | setParamCode (CbcGenParamCode code)
| Set the parameter code.
CbcGenCtlBlk * | obj () const
| Get the underlying cbc-generic control object.
void | setObj (CbcGenCtlBlk *obj)
| Set the underlying cbc-generic control object.
## Private Attributes
Data
CbcGenParamCode | paramCode_
| Parameter code.
CbcGenCtlBlk * | obj_
| cbc-generic control object

## Detailed Description

Class for cbc-generic control parameters.

Adds parameter type codes and push/pull functions to the generic parameter object.

Definition at line 34 of file CbcGenParam.hpp.

## Member Enumeration Documentation

enum CbcGenParam::CbcGenParamCode

Enumeration for cbc-generic parameters.

These are parameters that control the operation of the cbc-generic main program by operating on a CbcGenCtlBlk object. CBCGEN_FIRSTPARAM and CBCGEN_LASTPARM are markers to allow convenient separation of parameter groups.

Enumerator:

  CBCGEN_FIRSTPARAM |
  GENERALQUERY |
  FULLGENERALQUERY |
  HELP |
  BAB |
  CLEARCUTS |
  CLIQUECUTS |
  COMBINE |
  COSTSTRATEGY |
  CPP |
  CUTDEPTH |
  CUTSTRATEGY |
  DEBUG |
  DIRECTORY |
  DJFIX |
  DUMMY |
  ERRORSALLOWED |
  EXIT |
  EXPORT |
  FLOWCUTS |
  FPUMP |
  FPUMPITS |
  GOMORYCUTS |
  GREEDY |
  HEURISTICSTRATEGY |
  IMPORT |
  INTPRINT |
  KNAPSACKCUTS |
  LOCALTREE |
  LOGLEVEL |
  MESSAGES |
  MIPLIB |
  MIXEDCUTS |
  ODDHOLECUTS |
  OUTDUPROWS |
  OUTPUTFORMAT |
  PREPROCESS |
  PRINTMASK |
  PRINTOPTIONS |
  PRINTVERSION |
  PRIORITYIN |
  PROBINGCUTS |
  REDSPLITCUTS |
  ROUNDING |
  SOLUTION |
  SOLVECONTINUOUS |
  SOLVER |
  SOS |
  STDIN |
  STRENGTHEN |
  TIGHTENFACTOR |
  TWOMIRCUTS |
  UNITTEST |
  USERCBC |
  USESOLUTION |
  VERBOSE |
  SHOWUNIMP |
  CBCGEN_LASTPARAM |

Definition at line 49 of file CbcGenParam.hpp.

## Constructor & Destructor Documentation

CbcGenParam::CbcGenParam | ( |  | ) |

Default constructor.

CbcGenParam::CbcGenParam | ( | CbcGenParamCode | code,
|  | std::string | name,
|  | std::string | help,
|  | double | lower,
|  | double | upper,
|  | double | dflt = `0.0`,
|  | bool | display = `true` |
| ) |  |  |

Constructor for a parameter with a double value.

The default value is 0.0. Be careful to clearly indicate that `lower` and `upper` are real (double) values to distinguish this constructor from the constructor for an integer parameter.

CbcGenParam::CbcGenParam | ( | CbcGenParamCode | code,
|  | std::string | name,
|  | std::string | help,
|  | int | lower,
|  | int | upper,
|  | int | dflt = `0`,
|  | bool | display = `true` |
| ) |  |  |

Constructor for a parameter with an integer value.

The default value is 0.

CbcGenParam::CbcGenParam | ( | CbcGenParamCode | code,
|  | std::string | name,
|  | std::string | help,
|  | std::string | firstValue,
|  | int | dflt,
|  | bool | display = `true` |
| ) |  |  |

Constructor for a parameter with keyword values.

The string supplied as `firstValue` becomes the first keyword. Additional keywords can be added using appendKwd(). Keywords are numbered from zero. It's necessary to specify both the first keyword (`firstValue`) and the default keyword index (`dflt`) in order to distinguish this constructor from the string and action parameter constructors.

CbcGenParam::CbcGenParam | ( | CbcGenParamCode | code,
|  | std::string | name,
|  | std::string | help,
|  | std::string | dflt,
|  | bool | display = `true` |
| ) |  |  |

Constructor for a string parameter.

The default string value must be specified explicitly to distinguish a string constructor from an action parameter constructor.

CbcGenParam::CbcGenParam | ( | CbcGenParamCode | code,
|  | std::string | name,
|  | std::string | help,
|  | bool | display = `true` |
| ) |  |  |

Constructor for an action parameter.

CbcGenParam::CbcGenParam | ( | const CbcGenParam & | orig | ) |

Copy constructor.

CbcGenParam::~CbcGenParam | ( |  | ) |

Destructor.

## Member Function Documentation

CbcGenParam* CbcGenParam::clone | ( |  | ) | `[virtual]`

Clone.

Reimplemented from CoinParam.

CbcGenParam& CbcGenParam::operator= | ( | const CbcGenParam & | rhs | ) |

Assignment.

Reimplemented from CoinParam.

CbcGenParamCode CbcGenParam::paramCode | ( |  | ) | const`[inline]`

Get the parameter code.

Definition at line 148 of file CbcGenParam.hpp.

void CbcGenParam::setParamCode | ( | CbcGenParamCode | code | ) | `[inline]`

Set the parameter code.

Definition at line 154 of file CbcGenParam.hpp.

CbcGenCtlBlk* CbcGenParam::obj | ( |  | ) | const`[inline]`

Get the underlying cbc-generic control object.

Definition at line 160 of file CbcGenParam.hpp.

void CbcGenParam::setObj | ( | CbcGenCtlBlk * | obj | ) | `[inline]`

Set the underlying cbc-generic control object.

Definition at line 166 of file CbcGenParam.hpp.

## Member Data Documentation

CbcGenParamCode CbcGenParam::paramCode_`[private]`

Parameter code.

Definition at line 179 of file CbcGenParam.hpp.

CbcGenCtlBlk* CbcGenParam::obj_`[private]`

cbc-generic control object

Definition at line 182 of file CbcGenParam.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.7.8/Cbc/src/CbcGenParam.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines